close all

% Load data
load basisData.mat
Xtest = [min(X):.1:max(X)]';
T = size(Xtest,1);

% Plot data
figure(1);
plot(X,y,'b.')
title('Training Data');
hold on

for m = 0:8
% Compute basis
PhiX = polyBasis(X,m);

% Fit least-squares estimator
w = fitL2(PhiX,y);

% Draw model prediction
for i = 1:T
    yHat(i) = polyBasis(Xtest(i,:),m)*w;
end
subplot(3,3,m+1);
plot(X,y,'b.')
hold on
plot(Xtest,yHat,'g-');
title(sprintf('Degree %d',m));
end
