function [w,wp,m] = shooting(X, y, lambda)
[N,d] = size(X);

w = zeros(d,1);

XX2 = X'*X;
Xy2 = X'*y;
while 1
    w_old = w;
    for j = 1:d
        S0 = sum(XX2(j,:)*w) - XX2(j,j)*w(j) - Xy2(j);
        if S0 > lambda
            w(j,1) = (lambda - S0)/XX2(j,j);
        elseif S0 < -lambda
            w(j,1) = (-lambda - S0)/XX2(j,j);
        elseif abs(S0) <= lambda
            w(j,1) = 0;
        end
    end
    if max(abs(w-w_old)) < 1e-5
        break;
    end
end
